/*
* HMG Grid Demo
* (c) 2005 Roberto Lopez
*/
#include "hmg.ch"

Function Main

   Local aRows [75] [5]
   private aGridData := {}
   set date ital
   set century on   
   
   loaddata()

	define window Form_1 aT 0, 0 width 640 height 440 title 'GridPlus' MAIN
      define grid grid_1
         row 10
         col 10
         width 620
         height 330
         headers { "SalesMan", "Region", "Product", "Quantity", "Rate", "Amount" }
         widths { 100, 100, 100, 100, 100, 100 }  
         justify { 0, 0, 0, 1, 1, 1 } 
         items aGridData
         value 1
      end grid
      define button button_1
         row 340
         col 10
         caption "Print"
         action doprint()
      end button
	end window
   form_1.center
   form_1.activate
RETURN


function doprint
   oGridPlus := GridPlus():new()
   with object oGridPlus
      :addGridData( 'Form_1', 'grid_1' )
      :ReportHeader1 := 'XYZ Company'
      :ReportHeader2 := 'Sales Report From 01-11-2016 to 20-11-2016'
      :ColumnWidths := { 20, 20, 20, 20, 20, 20 } // mm
      :ReportFooter := 'User: S. Rathinagiri'
      :IncludeDate := .t.
      :IncludeTime := .t.
      :DateTimeAlignment := 2 // center
      :ColumnSum := { 6 }
      :GroupColumns := { 1, 2, 3 }
      :MergeHeaders := { { 1, 3, 'Sales Details' }, { 4, 6, 'Product Details' } }
      :ShowGUI() // or PrintGrid() for direct print preview without showing GridPlus window
//      :PrintGrid()
   endwith
return nil

function loaddata
   select a
   use sales
   go top
   do while .not. eof()
      aadd( aGridData, { a->salesman, a->region, a->Product, str( a->quantity ), str( a->Rate ), str( a->amount ) } )
      skip
   enddo
   asort( aGridData, , , { |x,y| if( x[1] == y[1], if( x[ 2 ] == y[ 2 ], x[ 3 ] < y[ 3 ], x[ 2 ] < y[ 2 ] ), x[ 1 ] < y[ 1 ] ) } )
   
return nil